#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_SMBUS
/* assume SMBus ioctl support, only for FreeBSD? */

#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>

#include <machine/smb.h>

#include "methods.h"
static int iosmb;

static int OpenIO()
{
  char byte;
  struct smbcmd cmd;
  cmd.slave=LM_ADDR;
  cmd.data.byte_ptr=&byte;

  if((iosmb=open("/dev/smb0",000))<0){
	return -1;
  }
  cmd.cmd=0x47;
  if(ioctl(iosmb,SMB_READB,&cmd)==-1){
	perror("ioctl(smb0)");
	return -1;
  }
  return 0;
}

static int CloseIO()
{
  close(iosmb);
}

static WriteByte(int addr,int value)
{
  struct smbcmd cmd;
  cmd.slave=LM_ADDR;
  cmd.cmd=addr;
  cmd.data.byte=value;
  if(ioctl(iosmb,SMB_WRITEB,&cmd)==-1){
	perror("ioctl(smb0)");
	exit(-1);
  }
}

static int ReadByte(int addr)
{
  struct smbcmd cmd;
  char ret;
  cmd.slave=LM_ADDR;
  cmd.cmd=addr;
  cmd.data.byte_ptr=&ret;
  if(ioctl(iosmb,SMB_READB,&cmd)==-1){
	perror("ioctl(smb0)");
	exit(-1);
  }
  return (int) (ret & 0xFF);
}

static int ReadTemp1()
{
  struct smbcmd cmd;
  short ret;
  cmd.slave=WBtemp1_ADDR;
  cmd.cmd=0x0;
  cmd.data.word_ptr=&ret;
  if(ioctl(iosmb,SMB_READW,&cmd)==-1){
	perror("ioctl(smb0)");
	exit(-1);
  }
  return (int) (ret & 0xFFFF);
}
static int ReadTemp2()
{
  struct smbcmd cmd;
  short ret;
  cmd.slave=WBtemp2_ADDR;
  cmd.cmd=0x0;
  cmd.data.word_ptr=&ret;
  if(ioctl(iosmb,SMB_READW,&cmd)==-1){
	perror("ioctl(smb0)");
	exit(-1);
  }
  return (int) (ret & 0xFFFF);
}

struct lm_methods method_smb={
  OpenIO,CloseIO,ReadByte,WriteByte,ReadTemp1,ReadTemp2
};

#endif
