
/* Direct access to VIA 686 Hardware Monitor Chip */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

/* VIA's HWM Base Address, global */
int  viahwm_base;

#include <fcntl.h>

#ifndef LINUX	/* FreeBSD */
#include <machine/cpufunc.h>
#define OUTb(x,y)	outb((x),(y))
#define WAIT	outb(0xEB,0x00)
#else			/* LINUX */
#include <unistd.h>
#include <asm/io.h>
#define OUTb(x,y)	outb((y),(x))
#define WAIT	outb(0x00,0xEB)
#endif

#include "methods.h"
static int iofl;

static int OpenIO()
{
	if (viahwm_base <= 0) {
		perror("VIA686's HWM Base Address invalid!");
		return -1;
	}
#ifndef LINUX
  if((iofl=open("/dev/io",000))<0){
	return -1;
  }
#else
  iopl(3);
#endif

  return 0;
}
static int CloseIO()
{
#ifndef LINUX
  close(iofl);
#else
  iopl(0);
#endif
}

static WriteByte(int addr,int value)
{
  OUTb(viahwm_base + addr,value); WAIT;
}

static int ReadByte(int addr)
{
  int ret;
  ret = inb(viahwm_base + addr); WAIT;
  return (ret & 0xFF);
}

static int ReadTemp1()
{
  return ReadByte(viahwm_base + 0x21);
}

static int ReadTemp2()
{
  return ReadByte(viahwm_base + 0x1F);
}

struct lm_methods method_via={
  OpenIO,CloseIO,ReadByte,WriteByte,ReadTemp1,ReadTemp2
};
