

/* Looking for Power Management ChipSet by checking
	the PCI Configuration Register, by YRS 2001.08.
	Information on how to access SMBus is provided
	by ":p araffin.(Yoneya)", MANY THANKS!!
 */

#include <fcntl.h>
#include <sys/types.h>

#ifndef LINUX	/* FreeBSD */
#include <machine/cpufunc.h>
#define OUTl(x,y)	outl((x),(y))
#define WAIT	outb(0xEB,0x00)
#else			/* LINUX */
#include <unistd.h>
#include <asm/io.h>
#define OUTl(x,y)	outl((y),(x))
#define WAIT	outb(0x00,0xEB)
#endif

#ifndef NULL
#define NULL 0x00
#endif

#define PCI_BUSN	0x0000		/* assume PCI Bus number = 0x00 for chipset */
#define PCI_REGM	64
#define PCI_DEVM	32
#define PCI_FUNM	8

#define PCI_CFIO	0x0CF8
#define PCI_CREAD	0x0CFC

#define getSMBBA1	0x90	/* VIA686,VIA596, PIIX4 */
#define getSMBBA2	0xD0	/* VIA8233 */
#define getSMBBA3	0x20	/* Intel801_ICH's */
#define getSMBBA4	0x58	/* AMD756 */

#define ID_VIA686	0x30571106
#define ID_VIA596	0x30501106
#define ID_VIA596B	0x30511106
#define ID_VIA8233	0x30741106
#define ID_PIIX4	0x71138086
#define ID_I801AA	0x24138086
#define ID_I801AB	0x24238086
#define ID_I801BA	0x24438086
#define ID_I801CA	0x24838086
#define ID_AMD756	0x740B1022
#define ID_AMD766	0x74131022

#define VIA686HWM_prob	0x74
#define VIA686HWM_base	0x70

#define VIA686SMB	1
#define VIA686HWM	2
#define VIA596SMB	11
#define PIIX4SMB	21
#define VIA8233SMB	31
#define ICH801SMB	41
#define AMD756SMB	51

int chk_port_byte(int);
int pci_hwm_smb_prob(int *, int *);
int pci_smb_prob(int [], u_int []);
u_int pci_conf_read(u_short, u_short, u_short, u_short);
